DefaultTlsServer (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.crypto.tls

## Class DefaultTlsServer

- java.lang.Object
- - org.bouncycastle.crypto.tls.AbstractTlsPeer
  - - org.bouncycastle.crypto.tls.AbstractTlsServer
    - - org.bouncycastle.crypto.tls.DefaultTlsServer

- All Implemented Interfaces:
    TlsPeer, TlsServer
  Direct Known Subclasses:
    MockDTLSServer

      public abstract class DefaultTlsServer
      extends AbstractTlsServer

- - ### Field Summary

    - ### Fields inherited from class org.bouncycastle.crypto.tls.AbstractTlsServer

      `cipherFactory, clientECPointFormats, clientExtensions, clientVersion, context, eccCipherSuitesOffered, encryptThenMACOffered, maxFragmentLengthOffered, namedCurves, offeredCipherSuites, offeredCompressionMethods, selectedCipherSuite, selectedCompressionMethod, serverECPointFormats, serverExtensions, serverVersion, supportedSignatureAlgorithms, truncatedHMacOffered`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultTlsServer()`
    `DefaultTlsServer(TlsCipherFactory cipherFactory)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected TlsKeyExchange` | `createDHEKeyExchange(int keyExchange)`
    `protected TlsKeyExchange` | `createDHKeyExchange(int keyExchange)`
    `protected TlsKeyExchange` | `createECDHEKeyExchange(int keyExchange)`
    `protected TlsKeyExchange` | `createECDHKeyExchange(int keyExchange)`
    `protected TlsKeyExchange` | `createRSAKeyExchange()`
    `TlsCipher` | `getCipher()`
    `protected int[]` | `getCipherSuites()`
    `TlsCredentials` | `getCredentials()`
    `protected DHParameters` | `getDHParameters()`
    `protected TlsSignerCredentials` | `getDSASignerCredentials()`
    `protected TlsSignerCredentials` | `getECDSASignerCredentials()`
    `TlsKeyExchange` | `getKeyExchange()`
    `protected TlsEncryptionCredentials` | `getRSAEncryptionCredentials()`
    `protected TlsSignerCredentials` | `getRSASignerCredentials()`

    - ### Methods inherited from class org.bouncycastle.crypto.tls.AbstractTlsServer

      `allowEncryptThenMAC, allowTruncatedHMac, checkServerExtensions, getCertificateRequest, getCertificateStatus, getCompression, getCompressionMethods, getMaximumVersion, getMinimumVersion, getNewSessionTicket, getSelectedCipherSuite, getSelectedCompressionMethod, getServerExtensions, getServerSupplementalData, getServerVersion, init, notifyClientCertificate, notifyClientVersion, notifyFallback, notifyOfferedCipherSuites, notifyOfferedCompressionMethods, processClientExtensions, processClientSupplementalData, supportsClientECCCapabilities`

    - ### Methods inherited from class org.bouncycastle.crypto.tls.AbstractTlsPeer

      `notifyAlertRaised, notifyAlertReceived, notifyHandshakeComplete, notifySecureRenegotiation, shouldUseGMTUnixTime`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.bouncycastle.crypto.tls.TlsPeer

      `notifyAlertRaised, notifyAlertReceived, notifyHandshakeComplete, notifySecureRenegotiation, shouldUseGMTUnixTime`

- - ### Constructor Detail

    - #### DefaultTlsServer

          public DefaultTlsServer()

    - #### DefaultTlsServer

          public DefaultTlsServer(TlsCipherFactory cipherFactory)

  - ### Method Detail

    - #### getDSASignerCredentials

          protected TlsSignerCredentials getDSASignerCredentials()
                                                          throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getECDSASignerCredentials

          protected TlsSignerCredentials getECDSASignerCredentials()
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getRSAEncryptionCredentials

          protected TlsEncryptionCredentials getRSAEncryptionCredentials()
                                                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getRSASignerCredentials

          protected TlsSignerCredentials getRSASignerCredentials()
                                                          throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getDHParameters

          protected DHParameters getDHParameters()

    - #### getCipherSuites

          protected int[] getCipherSuites()

      Specified by:
        `getCipherSuites` in class `AbstractTlsServer`

    - #### getCredentials

          public TlsCredentials getCredentials()
                                        throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getKeyExchange

          public TlsKeyExchange getKeyExchange()
                                        throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### getCipher

          public TlsCipher getCipher()
                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createDHKeyExchange

          protected TlsKeyExchange createDHKeyExchange(int keyExchange)

    - #### createDHEKeyExchange

          protected TlsKeyExchange createDHEKeyExchange(int keyExchange)

    - #### createECDHKeyExchange

          protected TlsKeyExchange createECDHKeyExchange(int keyExchange)

    - #### createECDHEKeyExchange

          protected TlsKeyExchange createECDHEKeyExchange(int keyExchange)

    - #### createRSAKeyExchange

          protected TlsKeyExchange createRSAKeyExchange()